=== modified file 'NEWS'
--- NEWS	2007-08-16 07:29:36 +0000
+++ NEWS	2007-08-24 14:00:55 +0000
@@ -2,16 +2,22 @@
 
  FEATURES
 
+  * Add ability to hide ignored files (#134121, Tom Badran)
+
   * Show tags in bzr viz. (Jelmer)
 
   * Handle large files correctly in Olive. (#127392, Mateusz Korniak)
 
-  * Support DBus being present but NetworkManager missing. (#126767, Mateusz 
-															Korniak, Jelmer)
+  * Support DBus being present but NetworkManager missing. (#126767, Mateusz
+  Korniak, Jelmer)
 
   * Add remove and delete menu item in Olive. (#127392, Mateusz Korniak)
   
+  * Added "update" menu item in Olive. (Mateusz Korniak)
+  
   * New Olive application icon. (Simon Pascal Klein)
+  
+  * Show bzr viz interface quickly. (Gary van der Merwe)
 
  UI
   
@@ -21,6 +27,20 @@
  
   * Updated pot generator script and regenerated the translation template.
     (Szilveszter)
+    
+ BUG FIXES
+ 
+  * Fixed interface to push.PushDialog (Mateusz Korniak)
+
+  * Fix so the when Olive is run from the source code, the toolbar and menu
+    icons show. (Gary van der Merwe)
+
+  * Fix a regression that Olive was no longer able to find bzrlib location
+    due to a change in the output of "bzr version". (Gary van der Merwe)
+
+  * Fix a regression that Olive branch info window was not working. (Gary van
+    der Merwe)
+    
 
 0.18.0  2007-07-17
 

=== modified file 'TODO'
--- TODO	2007-07-07 22:02:45 +0000
+++ TODO	2007-08-23 10:17:40 +0000
@@ -4,6 +4,7 @@
 - List unknown files in commit dialog
 - Allow merging revisions from missing dialog
 - It should be possible to add unknown files from the commit dialog.
+  Deleting selected unknown files should be also possible ?
 - Eliminate radiobuttons in push but rather show the default location and 
   allow the user to change it
 - Remove the status window as it's pointless since the status is already shown
@@ -19,3 +20,9 @@
   should keep a read lock open and only release this when the url is changed.
   It should also allow the creator of the window to supply an already opened
   branch, and a revision id.
+- olive-gtk: Allow diffing with external programs (kdiff3, meld? )
+  Allowing to revert parts of modified using external tools
+- olive-gtk: History of recently opened branches/checkouts
+- olive-gtk: Info about current director in status line (is it branch/checkout , parent branch/ checkout root)
+- olive-gtk: Info about dirs state (including summary of state files and dirs inside directory)
+- olive-gtk: mark modified, deleted files in dir with colors

=== modified file '__init__.py'
--- __init__.py	2007-08-10 14:16:09 +0000
+++ __init__.py	2007-08-23 10:17:40 +0000
@@ -59,7 +59,7 @@
         from bzrlib.errors import BzrError
         warning('Installed bzr version %s is too old to be used with bzr-gtk'
                 ' %s.' % (bzrlib.__version__, __version__))
-        raise BzrError('Version mismatch: %r' % version_info)
+        raise BzrError('Version mismatch: %r' % (version_info,) )
     else:
         warning('bzr-gtk is not up to date with installed bzr version %s.'
                 ' \nThere should be a newer version available, e.g. %i.%i.' 

=== modified file 'annotate/colormap.py'
--- annotate/colormap.py	2006-05-19 16:56:46 +0000
+++ annotate/colormap.py	2007-08-16 14:31:02 +0000
@@ -95,6 +95,7 @@
     def get_color(self, revision, now):
         days = self._days(revision, now)
         saturation = 255/((days/50) + 1)
-        hue = self.hue(self.committer_angle(revision.committer))
+        hue = self.hue(self.committer_angle(revision.properties.get('author',
+                                            revision.committer)))
         color = tuple([self.saturate_v(saturation, h) for h in hue])
         return "#%x%x%x" % color

=== modified file 'annotate/gannotate.py'
--- annotate/gannotate.py	2007-03-19 14:04:43 +0000
+++ annotate/gannotate.py	2007-08-16 14:27:37 +0000
@@ -66,7 +66,7 @@
         self.revision_id = getattr(tree, 'get_revision_id', 
                                    lambda: CURRENT_REVISION)()
         
-        # [revision id, line number, committer, revno, highlight color, line]
+        # [revision id, line number, author, revno, highlight color, line]
         self.annomodel = gtk.ListStore(gobject.TYPE_STRING,
                                        gobject.TYPE_STRING,
                                        gobject.TYPE_STRING,
@@ -84,7 +84,8 @@
                     revno = committer = ""
                 else:
                     last_seen = revision.revision_id
-                    committer = revision.committer
+                    committer = revision.properties.get('author',
+                        revision.committer)
 
                 if revision.revision_id not in self.revisions:
                     self.revisions[revision.revision_id] = revision

=== modified file 'logview.py'
--- logview.py	2007-07-21 18:24:21 +0000
+++ logview.py	2007-08-16 14:52:00 +0000
@@ -58,6 +58,15 @@
             self.committer.set_text(revision.committer)
         else:
             self.committer.set_text("")
+        author = revision.properties.get('author', '')
+        if author != '':
+            self.author.set_text(author)
+            self.author.show()
+            self.author_label.show()
+        else:
+            self.author.hide()
+            self.author_label.hide()
+
         if revision.timestamp is not None:
             self.timestamp.set_text(format_date(revision.timestamp,
                                                 revision.timezone))
@@ -170,10 +179,27 @@
         self.revision_id.show()
 
         align = gtk.Alignment(1.0, 0.5)
+        self.author_label = gtk.Label()
+        self.author_label.set_markup("<b>Author:</b>")
+        align.add(self.author_label)
+        self.table.attach(align, 0, 1, 1, 2, gtk.FILL, gtk.FILL)
+        align.show()
+        self.author_label.show()
+
+        align = gtk.Alignment(0.0, 0.5)
+        self.author = gtk.Label()
+        self.author.set_selectable(True)
+        align.add(self.author)
+        self.table.attach(align, 1, 2, 1, 2, gtk.EXPAND | gtk.FILL, gtk.FILL)
+        align.show()
+        self.author.show()
+        self.author.hide()
+
+        align = gtk.Alignment(1.0, 0.5)
         label = gtk.Label()
         label.set_markup("<b>Committer:</b>")
         align.add(label)
-        self.table.attach(align, 0, 1, 1, 2, gtk.FILL, gtk.FILL)
+        self.table.attach(align, 0, 1, 2, 3, gtk.FILL, gtk.FILL)
         align.show()
         label.show()
 
@@ -181,7 +207,7 @@
         self.committer = gtk.Label()
         self.committer.set_selectable(True)
         align.add(self.committer)
-        self.table.attach(align, 1, 2, 1, 2, gtk.EXPAND | gtk.FILL, gtk.FILL)
+        self.table.attach(align, 1, 2, 2, 3, gtk.EXPAND | gtk.FILL, gtk.FILL)
         align.show()
         self.committer.show()
 
@@ -189,7 +215,7 @@
         label = gtk.Label()
         label.set_markup("<b>Branch nick:</b>")
         align.add(label)
-        self.table.attach(align, 0, 1, 2, 3, gtk.FILL, gtk.FILL)
+        self.table.attach(align, 0, 1, 3, 4, gtk.FILL, gtk.FILL)
         label.show()
         align.show()
 
@@ -197,7 +223,7 @@
         self.branchnick_label = gtk.Label()
         self.branchnick_label.set_selectable(True)
         align.add(self.branchnick_label)
-        self.table.attach(align, 1, 2, 2, 3, gtk.EXPAND | gtk.FILL, gtk.FILL)
+        self.table.attach(align, 1, 2, 3, 4, gtk.EXPAND | gtk.FILL, gtk.FILL)
         self.branchnick_label.show()
         align.show()
 
@@ -205,7 +231,7 @@
         label = gtk.Label()
         label.set_markup("<b>Timestamp:</b>")
         align.add(label)
-        self.table.attach(align, 0, 1, 3, 4, gtk.FILL, gtk.FILL)
+        self.table.attach(align, 0, 1, 4, 5, gtk.FILL, gtk.FILL)
         align.show()
         label.show()
 
@@ -213,7 +239,7 @@
         self.timestamp = gtk.Label()
         self.timestamp.set_selectable(True)
         align.add(self.timestamp)
-        self.table.attach(align, 1, 2, 3, 4, gtk.EXPAND | gtk.FILL, gtk.FILL)
+        self.table.attach(align, 1, 2, 4, 5, gtk.EXPAND | gtk.FILL, gtk.FILL)
         align.show()
         self.timestamp.show()
 
@@ -222,13 +248,13 @@
         self.tags_label.set_markup("<b>Tags:</b>")
         align.add(self.tags_label)
         align.show()
-        self.table.attach(align, 0, 1, 4, 5, gtk.FILL, gtk.FILL)
+        self.table.attach(align, 0, 1, 5, 6, gtk.FILL, gtk.FILL)
         self.tags_label.show()
 
         align = gtk.Alignment(0.0, 0.5)
         self.tags_list = gtk.VBox()
         align.add(self.tags_list)
-        self.table.attach(align, 1, 2, 4, 5, gtk.EXPAND | gtk.FILL, gtk.FILL)
+        self.table.attach(align, 1, 2, 5, 6, gtk.EXPAND | gtk.FILL, gtk.FILL)
         align.show()
         self.tags_list.show()
         self.tags_widgets = []

=== modified file 'olive-gtk'
--- olive-gtk	2007-04-19 21:30:38 +0000
+++ olive-gtk	2007-08-12 16:12:33 +0000
@@ -18,6 +18,7 @@
 
 import os
 import sys
+import re
 
 try:
     version_info = sys.version_info
@@ -75,11 +76,9 @@
         print >>sys.stderr, "bzr not found"
         sys.exit(1)
     else:
-        for i in s.splitlines():
-            if i.startswith("Using bzrlib: "):
-                path = os.path.split(i[14:])[0]
-                sys.path.append(path)
-                break
+        bzrlib_match = re.compile(r"bzrlib: (.*)[/\\]bzrlib").search(s)
+        if bzrlib_match:
+            sys.path.append(bzrlib_match.group(1))
         else:
             print >>sys.stderr, "Can't find bzrlib location"
             sys.exit(1)

=== modified file 'olive.glade'
--- olive.glade	2007-08-10 10:45:06 +0000
+++ olive.glade	2007-08-23 11:13:37 +0000
@@ -129,6 +129,14 @@
                       </widget>
                     </child>
                     <child>
+                      <widget class="GtkCheckMenuItem" id="menuitem_view_show_ignored_files">
+                        <property name="visible">True</property>
+                        <property name="label" translatable="yes">Show _ignored files</property>
+                        <property name="use_underline">True</property>
+                        <signal name="activate" handler="on_menuitem_view_show_ignored_files_activate"/>
+                      </widget>
+                    </child>
+                    <child>
                       <widget class="GtkSeparatorMenuItem" id="separator_view1">
                         <property name="visible">True</property>
                       </widget>
@@ -190,7 +198,7 @@
                         <child internal-child="image">
                           <widget class="GtkImage" id="image243">
                             <property name="visible">True</property>
-                            <property name="pixbuf">pull16.png</property>
+                            <property name="pixbuf">icons/pull16.png</property>
                           </widget>
                         </child>
                       </widget>
@@ -204,12 +212,21 @@
                         <child internal-child="image">
                           <widget class="GtkImage" id="image244">
                             <property name="visible">True</property>
-                            <property name="pixbuf">push16.png</property>
+                            <property name="pixbuf">icons/push16.png</property>
                           </widget>
                         </child>
                       </widget>
                     </child>
                     <child>
+                      <widget class="GtkMenuItem" id="menuitem_branch_update">
+                        <property name="visible">True</property>
+                        <property name="events">GDK_POINTER_MOTION_MASK | GDK_POINTER_MOTION_HINT_MASK | GDK_BUTTON_PRESS_MASK | GDK_BUTTON_RELEASE_MASK</property>
+                        <property name="label" translatable="yes">Update</property>
+                        <property name="use_underline">True</property>
+                        <signal name="activate" handler="on_menuitem_branch_update_activate"/>
+                      </widget>
+                    </child>
+                    <child>
                       <widget class="GtkSeparatorMenuItem" id="separator_branch2">
                         <property name="visible">True</property>
                       </widget>
@@ -239,7 +256,7 @@
                         <child internal-child="image">
                           <widget class="GtkImage" id="image245">
                             <property name="visible">True</property>
-                            <property name="pixbuf">commit16.png</property>
+                            <property name="pixbuf">icons/commit16.png</property>
                           </widget>
                         </child>
                       </widget>
@@ -301,7 +318,7 @@
                         <child internal-child="image">
                           <widget class="GtkImage" id="image246">
                             <property name="visible">True</property>
-                            <property name="pixbuf">diff16.png</property>
+                            <property name="pixbuf">icons/diff16.png</property>
                           </widget>
                         </child>
                       </widget>
@@ -315,7 +332,7 @@
                         <child internal-child="image">
                           <widget class="GtkImage" id="image247">
                             <property name="visible">True</property>
-                            <property name="pixbuf">log16.png</property>
+                            <property name="pixbuf">icons/log16.png</property>
                           </widget>
                         </child>
                       </widget>
@@ -452,6 +469,18 @@
                 <property name="expand">False</property>
               </packing>
             </child>
+            <child>
+              <widget class="GtkToolButton" id="toolbutton_update">
+                <property name="visible">True</property>
+                <property name="events">GDK_POINTER_MOTION_MASK | GDK_POINTER_MOTION_HINT_MASK | GDK_BUTTON_PRESS_MASK | GDK_BUTTON_RELEASE_MASK</property>
+                <property name="label" translatable="yes">Update</property>
+                <property name="icon">icons/pull.png</property>
+                <signal name="clicked" handler="on_toolbutton_update_clicked"/>
+              </widget>
+              <packing>
+                <property name="expand">False</property>
+              </packing>
+            </child>
           </widget>
           <packing>
             <property name="expand">False</property>
@@ -482,6 +511,7 @@
               </widget>
               <packing>
                 <property name="resize">False</property>
+                <property name="shrink">True</property>
               </packing>
             </child>
             <child>
@@ -500,6 +530,7 @@
                         <property name="receives_default">True</property>
                         <property name="events">GDK_POINTER_MOTION_MASK | GDK_POINTER_MOTION_HINT_MASK | GDK_BUTTON_PRESS_MASK | GDK_BUTTON_RELEASE_MASK</property>
                         <property name="relief">GTK_RELIEF_NONE</property>
+                        <property name="response_id">0</property>
                         <signal name="clicked" handler="on_button_location_up_clicked"/>
                         <child>
                           <widget class="GtkImage" id="image_location_up">
@@ -548,6 +579,7 @@
                         <property name="label" translatable="yes">gtk-jump-to</property>
                         <property name="relief">GTK_RELIEF_NONE</property>
                         <property name="use_stock">True</property>
+                        <property name="response_id">0</property>
                         <signal name="clicked" handler="on_button_location_jump_clicked"/>
                       </widget>
                       <packing>
@@ -574,6 +606,7 @@
                         <property name="events">GDK_POINTER_MOTION_MASK | GDK_POINTER_MOTION_HINT_MASK | GDK_BUTTON_PRESS_MASK | GDK_BUTTON_RELEASE_MASK</property>
                         <property name="label" translatable="yes">H_istory Mode</property>
                         <property name="use_underline">True</property>
+                        <property name="response_id">0</property>
                         <property name="draw_indicator">True</property>
                         <signal name="toggled" handler="on_checkbutton_history_toggled"/>
                       </widget>
@@ -605,6 +638,7 @@
                         <property name="can_focus">True</property>
                         <property name="receives_default">True</property>
                         <property name="events">GDK_POINTER_MOTION_MASK | GDK_POINTER_MOTION_HINT_MASK | GDK_BUTTON_PRESS_MASK | GDK_BUTTON_RELEASE_MASK</property>
+                        <property name="response_id">0</property>
                         <signal name="clicked" handler="on_button_history_browse_clicked"/>
                         <child>
                           <widget class="GtkImage" id="image_history_browse">
@@ -647,6 +681,10 @@
                   </packing>
                 </child>
               </widget>
+              <packing>
+                <property name="resize">True</property>
+                <property name="shrink">True</property>
+              </packing>
             </child>
           </widget>
           <packing>
@@ -716,6 +754,7 @@
             <property name="can_focus">True</property>
             <property name="label" translatable="yes">Selected only</property>
             <property name="use_underline">True</property>
+            <property name="response_id">0</property>
             <property name="draw_indicator">True</property>
           </widget>
           <packing>
@@ -730,6 +769,7 @@
             <property name="can_focus">True</property>
             <property name="label" translatable="yes">All unknowns recursively</property>
             <property name="use_underline">True</property>
+            <property name="response_id">0</property>
             <property name="draw_indicator">True</property>
             <property name="group">radiobutton_add_selected</property>
           </widget>
@@ -750,6 +790,7 @@
                 <property name="can_default">True</property>
                 <property name="label">gtk-cancel</property>
                 <property name="use_stock">True</property>
+                <property name="response_id">0</property>
                 <signal name="clicked" handler="on_button_add_cancel_clicked"/>
               </widget>
             </child>
@@ -759,6 +800,7 @@
                 <property name="can_focus">True</property>
                 <property name="can_default">True</property>
                 <property name="has_default">True</property>
+                <property name="response_id">0</property>
                 <signal name="clicked" handler="on_button_add_add_clicked"/>
                 <child>
                   <widget class="GtkAlignment" id="alignment3">
@@ -836,6 +878,7 @@
             <property name="can_focus">True</property>
             <property name="label" translatable="yes">Selected only</property>
             <property name="use_underline">True</property>
+            <property name="response_id">0</property>
             <property name="draw_indicator">True</property>
           </widget>
           <packing>
@@ -850,6 +893,7 @@
             <property name="can_focus">True</property>
             <property name="label" translatable="yes">All files with status 'added'</property>
             <property name="use_underline">True</property>
+            <property name="response_id">0</property>
             <property name="draw_indicator">True</property>
             <property name="group">radiobutton_remove_selected</property>
           </widget>
@@ -870,6 +914,7 @@
                 <property name="can_default">True</property>
                 <property name="label">gtk-cancel</property>
                 <property name="use_stock">True</property>
+                <property name="response_id">0</property>
                 <signal name="clicked" handler="on_button_remove_cancel_clicked"/>
               </widget>
             </child>
@@ -879,6 +924,7 @@
                 <property name="can_focus">True</property>
                 <property name="can_default">True</property>
                 <property name="has_default">True</property>
+                <property name="response_id">0</property>
                 <signal name="clicked" handler="on_button_remove_remove_clicked"/>
                 <child>
                   <widget class="GtkAlignment" id="alignment4">
@@ -956,6 +1002,7 @@
             <property name="can_focus">True</property>
             <property name="label" translatable="yes">_Versioned directory</property>
             <property name="use_underline">True</property>
+            <property name="response_id">0</property>
             <property name="active">True</property>
             <property name="draw_indicator">True</property>
           </widget>
@@ -976,6 +1023,7 @@
                 <property name="can_default">True</property>
                 <property name="label">gtk-cancel</property>
                 <property name="use_stock">True</property>
+                <property name="response_id">0</property>
                 <signal name="clicked" handler="on_button_mkdir_cancel_clicked"/>
               </widget>
             </child>
@@ -985,6 +1033,7 @@
                 <property name="can_focus">True</property>
                 <property name="can_default">True</property>
                 <property name="has_default">True</property>
+                <property name="response_id">0</property>
                 <signal name="clicked" handler="on_button_mkdir_mkdir_clicked"/>
                 <child>
                   <widget class="GtkAlignment" id="alignment8">
@@ -1085,6 +1134,7 @@
                 <property name="can_default">True</property>
                 <property name="label">gtk-cancel</property>
                 <property name="use_stock">True</property>
+                <property name="response_id">0</property>
                 <signal name="clicked" handler="on_button_move_cancel_clicked"/>
               </widget>
             </child>
@@ -1094,6 +1144,7 @@
                 <property name="can_focus">True</property>
                 <property name="can_default">True</property>
                 <property name="has_default">True</property>
+                <property name="response_id">0</property>
                 <signal name="clicked" handler="on_button_move_move_clicked"/>
                 <child>
                   <widget class="GtkAlignment" id="alignment9">
@@ -1192,6 +1243,7 @@
                 <property name="can_default">True</property>
                 <property name="label">gtk-cancel</property>
                 <property name="use_stock">True</property>
+                <property name="response_id">0</property>
                 <signal name="clicked" handler="on_button_rename_cancel_clicked"/>
               </widget>
             </child>
@@ -1201,6 +1253,7 @@
                 <property name="can_focus">True</property>
                 <property name="can_default">True</property>
                 <property name="has_default">True</property>
+                <property name="response_id">0</property>
                 <signal name="clicked" handler="on_button_rename_rename_clicked"/>
                 <child>
                   <widget class="GtkAlignment" id="alignment10">
@@ -2338,6 +2391,7 @@
                 <property name="has_default">True</property>
                 <property name="label">gtk-close</property>
                 <property name="use_stock">True</property>
+                <property name="response_id">0</property>
                 <signal name="clicked" handler="on_button_info_close_clicked"/>
               </widget>
             </child>
@@ -2387,6 +2441,7 @@
               <widget class="GtkButton" id="button_merge_open">
                 <property name="visible">True</property>
                 <property name="can_focus">True</property>
+                <property name="response_id">0</property>
                 <signal name="clicked" handler="on_button_merge_open_clicked"/>
                 <child>
                   <widget class="GtkImage" id="image240">
@@ -2419,6 +2474,7 @@
                 <property name="can_default">True</property>
                 <property name="label">gtk-cancel</property>
                 <property name="use_stock">True</property>
+                <property name="response_id">0</property>
                 <signal name="clicked" handler="on_button_merge_cancel_clicked"/>
               </widget>
             </child>
@@ -2428,6 +2484,7 @@
                 <property name="can_focus">True</property>
                 <property name="can_default">True</property>
                 <property name="has_default">True</property>
+                <property name="response_id">0</property>
                 <signal name="clicked" handler="on_button_merge_merge_clicked"/>
                 <child>
                   <widget class="GtkAlignment" id="alignment19">

=== modified file 'olive/__init__.py'
--- olive/__init__.py	2007-08-16 07:29:36 +0000
+++ olive/__init__.py	2007-08-24 13:40:48 +0000
@@ -101,12 +101,14 @@
         self.menuitem_file_move = self.toplevel.get_widget('menuitem_file_move')
         self.menuitem_file_annotate = self.toplevel.get_widget('menuitem_file_annotate')
         self.menuitem_view_show_hidden_files = self.toplevel.get_widget('menuitem_view_show_hidden_files')
+        self.menuitem_view_show_ignored_files = self.toplevel.get_widget('menuitem_view_show_ignored_files')
         self.menuitem_branch = self.toplevel.get_widget('menuitem_branch')
         self.menuitem_branch_init = self.toplevel.get_widget('menuitem_branch_initialize')
         self.menuitem_branch_get = self.toplevel.get_widget('menuitem_branch_get')
         self.menuitem_branch_checkout = self.toplevel.get_widget('menuitem_branch_checkout')
         self.menuitem_branch_pull = self.toplevel.get_widget('menuitem_branch_pull')
         self.menuitem_branch_push = self.toplevel.get_widget('menuitem_branch_push')
+        self.menuitem_branch_update = self.toplevel.get_widget('menuitem_branch_update')
         self.menuitem_branch_revert = self.toplevel.get_widget('menuitem_branch_revert')
         self.menuitem_branch_merge = self.toplevel.get_widget('menuitem_branch_merge')
         self.menuitem_branch_commit = self.toplevel.get_widget('menuitem_branch_commit')
@@ -124,6 +126,7 @@
         self.toolbutton_commit = self.toplevel.get_widget('toolbutton_commit')
         self.toolbutton_pull = self.toplevel.get_widget('toolbutton_pull')
         self.toolbutton_push = self.toplevel.get_widget('toolbutton_push')
+        self.toolbutton_update = self.toplevel.get_widget('toolbutton_update')
         # Get the drive selector
         self.combobox_drive = gtk.combo_box_new_text()
         self.combobox_drive.connect("changed", self._refresh_drives)
@@ -154,6 +157,7 @@
                 "on_menuitem_file_rename_activate": self.on_menuitem_file_rename_activate,
                 "on_menuitem_file_annotate_activate": self.on_menuitem_file_annotate_activate,
                 "on_menuitem_view_show_hidden_files_activate": self.on_menuitem_view_show_hidden_files_activate,
+                "on_menuitem_view_show_ignored_files_activate": self.on_menuitem_view_show_ignored_files_activate,
                 "on_menuitem_view_refresh_activate": self.on_menuitem_view_refresh_activate,
                 "on_menuitem_branch_initialize_activate": self.on_menuitem_branch_initialize_activate,
                 "on_menuitem_branch_get_activate": self.on_menuitem_branch_get_activate,
@@ -163,6 +167,7 @@
                 "on_menuitem_branch_commit_activate": self.on_menuitem_branch_commit_activate,
                 "on_menuitem_branch_push_activate": self.on_menuitem_branch_push_activate,
                 "on_menuitem_branch_pull_activate": self.on_menuitem_branch_pull_activate,
+                "on_menuitem_branch_update_activate": self.on_menuitem_branch_update_activate,                
                 "on_menuitem_branch_tags_activate": self.on_menuitem_branch_tags_activate,
                 "on_menuitem_branch_status_activate": self.on_menuitem_branch_status_activate,
                 "on_menuitem_branch_missing_revisions_activate": self.on_menuitem_branch_missing_revisions_activate,
@@ -177,6 +182,7 @@
                 "on_toolbutton_commit_clicked": self.on_menuitem_branch_commit_activate,
                 "on_toolbutton_pull_clicked": self.on_menuitem_branch_pull_activate,
                 "on_toolbutton_push_clicked": self.on_menuitem_branch_push_activate,
+                "on_toolbutton_update_clicked": self.on_menuitem_branch_update_activate,
                 "on_treeview_right_button_press_event": self.on_treeview_right_button_press_event,
                 "on_treeview_right_row_activated": self.on_treeview_right_row_activated,
                 "on_treeview_left_button_press_event": self.on_treeview_left_button_press_event,
@@ -223,6 +229,7 @@
 
         # Apply menu state
         self.menuitem_view_show_hidden_files.set_active(self.pref.get_preference('dotted_files', 'bool'))
+        self.menuitem_view_show_ignored_files.set_active(self.pref.get_preference('ignored_files', 'bool'))
 
         # We're starting local
         self.remote = False
@@ -560,10 +567,21 @@
         ret = branch_to.pull(branch_from)
         
         info_dialog(_('Pull successful'), _('%d revision(s) pulled.') % ret)
+        
+    @show_bzr_error
+    def on_menuitem_branch_update_activate(self, widget):
+        """ Brranch/checkout update menu handler. """
+        
+        ret = self.wt.update()
+        conflicts = self.wt.conflicts()
+        if conflicts:
+            info_dialog(_('Update successful but conflicts generated'), _('Number of conflicts generated: %d.') % (len(conflicts),) )
+        else:
+            info_dialog(_('Update successful'), _('No conflicts generated.') )
     
     def on_menuitem_branch_push_activate(self, widget):
         """ Branch/Push... menu handler. """
-        push = PushDialog(self.wt.branch, self.window)
+        push = PushDialog(repository=None,revid=None,branch=self.wt.branch, parent=self.window)
         response = push.run()
         if response != gtk.RESPONSE_NONE:
             push.destroy()
@@ -702,6 +720,12 @@
         if self.path is not None:
             self.refresh_right()
 
+    def on_menuitem_view_show_ignored_files_activate(self, widget):
+        """ Hide/Show ignored files menu handler. """
+        self.pref.set_preference('ignored_files', widget.get_active())
+        if self.path is not None:
+            self.refresh_right()
+            
     def on_treeview_left_button_press_event(self, widget, event):
         """ Occurs when somebody right-clicks in the bookmark list. """
         if event.button == 3:
@@ -1051,6 +1075,7 @@
             self.menuitem_branch_checkout.set_sensitive(self.notbranch)
             self.menuitem_branch_pull.set_sensitive(not self.notbranch)
             self.menuitem_branch_push.set_sensitive(not self.notbranch)
+            self.menuitem_branch_update.set_sensitive(not self.notbranch)
             self.menuitem_branch_revert.set_sensitive(not self.notbranch)
             self.menuitem_branch_merge.set_sensitive(not self.notbranch)
             self.menuitem_branch_commit.set_sensitive(not self.notbranch)
@@ -1072,6 +1097,7 @@
             self.toolbutton_commit.set_sensitive(not self.notbranch)
             self.toolbutton_pull.set_sensitive(not self.notbranch)
             self.toolbutton_push.set_sensitive(not self.notbranch)
+            self.toolbutton_update.set_sensitive(not self.notbranch)
         else:
             # We're remote
             self.menuitem_branch_init.set_sensitive(False)
@@ -1079,6 +1105,7 @@
             self.menuitem_branch_checkout.set_sensitive(True)
             self.menuitem_branch_pull.set_sensitive(False)
             self.menuitem_branch_push.set_sensitive(False)
+            self.menuitem_branch_update.set_sensitive(False)
             self.menuitem_branch_revert.set_sensitive(False)
             self.menuitem_branch_merge.set_sensitive(False)
             self.menuitem_branch_commit.set_sensitive(False)
@@ -1100,6 +1127,7 @@
             self.toolbutton_commit.set_sensitive(False)
             self.toolbutton_pull.set_sensitive(False)
             self.toolbutton_push.set_sensitive(False)
+            self.toolbutton_update.set_sensitive(False)
     
     def refresh_left(self):
         """ Refresh the bookmark list. """
@@ -1151,6 +1179,8 @@
     
             # Fill the appropriate lists
             dotted_files = self.pref.get_preference('dotted_files', 'bool')
+            ignored_files = self.pref.get_preference('ignored_files', 'bool')
+
             for item in os.listdir(path):
                 if not dotted_files and item[0] == '.':
                     continue
@@ -1232,6 +1262,8 @@
                     st = _('unchanged')
                 elif status == 'ignored':
                     st = _('ignored')
+                    if not ignored_files:
+                        continue
                 else:
                     st = _('unknown')
                 
@@ -1467,6 +1499,7 @@
         # Some default options
         self.defaults = { 'strict_commit' : False,
                           'dotted_files'  : False,
+                          'ignored_files' : True,
                           'window_width'  : 700,
                           'window_height' : 400,
                           'window_x'      : 40,

=== modified file 'olive/info_helper.py'
--- olive/info_helper.py	2007-04-19 21:35:53 +0000
+++ olive/info_helper.py	2007-08-12 21:14:51 +0000
@@ -20,11 +20,33 @@
 
 import bzrlib
 
-import bzrlib.osutils as osutils
+from bzrlib import (
+    bzrdir,
+    diff,
+    errors,
+    osutils,
+    urlutils,
+    )
 
-from bzrlib.info import _repo_rel_url
 from bzrlib.missing import find_unmerged
 
+def _repo_rel_url(repo_url, inner_url):
+    """Return path with common prefix of repository path removed.
+
+    If path is not part of the repository, the original path is returned.
+    If path is equal to the repository, the current directory marker '.' is
+    returned.
+    Otherwise, a relative path is returned, with trailing '/' stripped.
+    """
+    inner_url = urlutils.normalize_url(inner_url)
+    repo_url = urlutils.normalize_url(repo_url)
+    if inner_url == repo_url:
+        return '.'
+    result = urlutils.relative_url(repo_url, inner_url)
+    if result != inner_url:
+        result = result.rstrip('/')
+    return result
+
 def get_location_info(repository, branch=None, working=None):
     """ Get known locations for working, branch and repository.
     

=== modified file 'viz/branchwin.py'
--- viz/branchwin.py	2007-07-21 18:40:41 +0000
+++ viz/branchwin.py	2007-08-24 11:48:03 +0000
@@ -172,11 +172,15 @@
                                    gobject.TYPE_PYOBJECT,
                                    str, str, str)
         self.index = {}
+        self.set_title(branch.nick + " - bzrk")
+        gobject.idle_add(self.populate_model, start, maxnum)
+
+    def populate_model(self, start, maxnum):
         index = 0
-
+        
         last_lines = []
         (self.revisions, colours, self.children, self.parent_ids,
-            merge_sorted) = distances(branch.repository, start)
+            merge_sorted) = distances(self.branch.repository, start)
         for (index, (revision, node, lines)) in enumerate(graph(
                 self.revisions, colours, merge_sorted)):
             # FIXME: at this point we should be able to show the graph order
@@ -193,10 +197,10 @@
             last_lines = lines
             if maxnum is not None and index > maxnum:
                 break
-
-        self.set_title(branch.nick + " - bzrk")
         self.treeview.set_model(self.model)
-
+        return False
+    
+    
     def _treeview_cursor_cb(self, *args):
         """Callback for when the treeview cursor changes."""
         (path, col) = self.treeview.get_cursor()

